package org.jeecg.modules.ctop.controller;

import cn.com.ctop.kuaishou.modules.material.entity.KuaishouAccessToken;
import cn.com.ctop.kuaishou.modules.material.entity.KuaishouResultToken;
import cn.com.ctop.kuaishou.modules.material.service.IKuaishouAccessTokenService;
import cn.com.ctop.kuaishou.modules.material.service.IKuaishouInterfaceService;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Date;

@Controller
@RequestMapping("/")
public class CallbackController {
    @Autowired
    private IKuaishouInterfaceService kuaishouInterfaceService;
    @Autowired
    private IKuaishouAccessTokenService kuaishouAccessTokenService;
    @RequestMapping("/kuaishou")
    @ResponseBody
    public String kuaishou(HttpServletRequest request,
                           HttpServletResponse response,
                           @RequestParam("auth_code")String authCode,
                           @RequestParam("state")String state) {
        System.out.println(request.getQueryString());
        if(StringUtils.isNotBlank(authCode)){
            KuaishouResultToken accessToken = kuaishouInterfaceService.getAccessToken(authCode);
            KuaishouAccessToken token = accessToken.getData();
            if(token != null){
                long now = System.currentTimeMillis();
                long accessTokenExpireIn = token.getAccessTokenExpiresIn() * 1000L;
                long refreshTokenExpireIn = token.getRefreshTokenExpiresIn() * 1000L;
                Date accessTokenExpireInDate = new Date(now+accessTokenExpireIn);
                Date refreshTokenExpireInDate = new Date(now+refreshTokenExpireIn);
                token.setAccessTokenExpiresInDate(accessTokenExpireInDate);
                token.setRefreshTokenExpiresInDate(refreshTokenExpireInDate);
                kuaishouAccessTokenService.saveOrUpdate(token);
            }
            return "auth_success";
        }
        return "auth_fail";
    }
}
