package org.jeecg.modules.ctop.entity;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * @Description: 头条广告主账户预算信息
 * @Author: jeecg-boot
 * @Date:   2019-07-10
 * @Version: V1.0
 */
@Data
@TableName("ctop_toutiao_advertiser_budget")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="ctop_toutiao_advertiser_budget对象", description="头条广告主账户预算信息")
public class CtopToutiaoAdvertiserBudget {
    
	/**头条广告主id*/
	@TableId()
    @ApiModelProperty(value = "头条广告主id")
	private Long id;
	/**平台账号id*/
	@Excel(name = "平台账号id", width = 15)
    @ApiModelProperty(value = "平台账号id")
	private String advertiserId;
	@Excel(name = "预算类型", width = 15)
    @ApiModelProperty(value = "预算类型")
	private java.lang.String budgetMode;
	@Excel(name = "预算数量", width = 15)
    @ApiModelProperty(value = "预算数量")
	private Integer budget;
	/**createTime*/
    @ApiModelProperty(value = "createTime")
	private java.util.Date createTime;
	/**updateTime*/
    @ApiModelProperty(value = "updateTime")
	private java.util.Date updateTime;

	public CtopToutiaoAdvertiserBudget() {
	}

	public CtopToutiaoAdvertiserBudget(JSONObject dataObject, String accountId) {
		Long advertiserId = dataObject.getLong("advertiser_id");
		this.id = advertiserId;
		this.advertiserId = accountId;
		String budget_mode = dataObject.getString("budget_mode");
		if (null!=budget_mode&&!"".equals(budget_mode.trim())){
			this.budgetMode =budget_mode;
		}
		Integer budget = dataObject.getInteger("budget");
		if (null!=budget){
			this.budget =budget;
		}
	}
}
