package org.jeecg.modules.ctop.entity;

import java.io.Serializable;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * @Description: 预算与出价模块模板
 * @Author: jeecg-boot
 * @Date:   2019-07-17
 * @Version: V1.0
 */
@Data
@TableName("ctop_toutiao_budget_template")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="ctop_toutiao_budget_template对象", description="预算与出价模块模板")
public class CtopToutiaoBudgetTemplate {
    
	/**id*/
	@TableId(type = IdType.UUID)
    @ApiModelProperty(value = "id")
	private Integer id;
	/**广告主id*/
	@Excel(name = "广告主id", width = 15)
    @ApiModelProperty(value = "广告主id")
	private String advertiserId;
	/**头条账号id*/
	@Excel(name = "头条账号id", width = 15)
    @ApiModelProperty(value = "头条账号id")
	private Integer toutiaoId;
	/**bidType*/
	@Excel(name = "bidType", width = 15)
    @ApiModelProperty(value = "bidType")
	private String bidType;
	/**flowcontrolmode*/
	@Excel(name = "flowcontrolmode", width = 15)
    @ApiModelProperty(value = "flowcontrolmode")
	private String flowcontrolmode;
	/**budgetprice*/
	@Excel(name = "budgetprice", width = 15)
    @ApiModelProperty(value = "budgetprice")
	private String budgetprice;
	/**budgetmode*/
	@Excel(name = "budgetmode", width = 15)
    @ApiModelProperty(value = "budgetmode")
	private String budgetmode;
	/**flowdate*/
	@Excel(name = "flowdate", width = 15)
    @ApiModelProperty(value = "flowdate")
	private String flowdate;
	/**dateflowrange*/
	@Excel(name = "dateflowrange", width = 15)
    @ApiModelProperty(value = "dateflowrange")
	private String dateflowrange;
	/**datequantum*/
	@Excel(name = "datequantum", width = 15)
    @ApiModelProperty(value = "datequantum")
	private String datequantum;
	/**datequantumrange*/
	@Excel(name = "datequantumrange", width = 15)
    @ApiModelProperty(value = "datequantumrange")
	private String datequantumrange;
	/**pricetype*/
	@Excel(name = "pricetype", width = 15)
    @ApiModelProperty(value = "pricetype")
	private String pricetype;
	/**convertprice*/
	@Excel(name = "convertprice", width = 15)
    @ApiModelProperty(value = "convertprice")
	private String convertprice;
	/**filtertype*/
	@Excel(name = "filtertype", width = 15)
    @ApiModelProperty(value = "filtertype")
	private String filtertype;
	/**status*/
	@Excel(name = "status", width = 15)
    @ApiModelProperty(value = "status")
	private Integer status;
	/**createTime*/
    @ApiModelProperty(value = "createTime")
	private Date createTime;
	/**updateTime*/
    @ApiModelProperty(value = "updateTime")
	private Date updateTime;
}
