package cn.com.ctop.kuaishou.modules.material.service.impl;

import cn.com.ctop.common.utils.DateUtils;
import cn.com.ctop.kuaishou.modules.material.entity.*;
import cn.com.ctop.kuaishou.modules.material.service.*;
import cn.com.ctop.kuaishou.modules.report.entity.*;
import cn.com.ctop.kuaishou.modules.report.service.*;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service
public class KuaishouServiceImpl implements IKuaishouService {
    @Autowired
    private IKuaishouInterfaceService kuaishouInterfaceService;
    @Autowired
    private IKuaishouReportDailyAccountService kuaishouReportDailyAccountService;
    @Autowired
    private IKuaishouReportHourlyAccountService kuaishouReportHourlyAccountService;
    @Autowired
    private IKuaishouReportDailyCampaignService kuaishouReportDailyCampaignService;
    @Autowired
    private IKuaishouReportHourlyCampaignService kuaishouReportHourlyCampaignService;
    @Autowired
    private IKuaishouReportDailyGroupService kuaishouReportDailyGroupService;
    @Autowired
    private IKuaishouReportHourlyGroupService kuaishouReportHourlyGroupService;
    @Autowired
    private IKuaishouReportDailyCreativeService kuaishouReportDailyCreativeService;
    @Autowired
    private IKuaishouReportHourlyCreativeService kuaishouReportHourlyCreativeService;
    @Autowired
    private IKuaishouCreativeService kuaishouCreativeService;
    @Autowired
    private IKuaishouGroupService kuaishouGroupService;
    @Autowired
    private IKuaishouCampaignService kuaishouCampaignService;
    @Autowired
    private IKuaishouAppInfoService kuaishouAppInfoService;
    @Autowired
    private IKuaishouDisplayInfoService kuaishouDisplayInfoService;
    @Autowired
    private IKuaishouScheduleService kuaishouScheduleService;

    public static void main(String[] args){
        KuaishouServiceImpl i = new KuaishouServiceImpl();
        try {
            List<Map<String,String>> list = DateUtils.getDateDayRange("2019-01-01","2019-06-21");
            for (Map<String,String> map :list){
                System.out.println(map.get("startDate")+"-"+map.get("endDate"));
            }
//            i.getReportByDay("297c47b469d1391e5e048fe14abc2a01",2289L,"2019-01-01","2019-06-14");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public void getReportByDay(String accessToken, Long advertiserId, String startDate, String endDate) throws Exception{
        //按月做分段 最大6个月
        if(DateUtils.compareDate(startDate,endDate) > 0){
            return;
        }else{
            List<Map<String,String>> list = DateUtils.getDateMonthRange(startDate,endDate);
            for (Map<String,String> map :list){
                System.out.println(map.get("startDate")+"-"+map.get("endDate"));
                this.getAccountDailyReportByPage(accessToken,advertiserId,map.get("startDate"),map.get("endDate"),null,null);
                this.getCampaignDailyReportByPage(accessToken,advertiserId,map.get("startDate"),map.get("endDate"),null,null);
                this.getGroupDailyReportByPage(accessToken,advertiserId,map.get("startDate"),map.get("endDate"),null,null);
                this.getCreativeDailyReportByPage(accessToken,advertiserId,map.get("startDate"),map.get("endDate"),null,null);
            }
        }
    }

    @Override
    public void getReportByHour(String accessToken, Long advertiserId, String startDate, String endDate) throws Exception{
        //按日期做分段  最大七天
        if(DateUtils.compareDate(startDate,endDate) > 0){
            return;
        }else{
            List<Map<String,String>> list = DateUtils.getDateDayRange(startDate,endDate);
            for (Map<String,String> map :list){
                System.out.println(map.get("startDate")+"-"+map.get("endDate"));
                this.getAccountHourlyReportByPage(accessToken,advertiserId,map.get("startDate"),map.get("endDate"),null,null);
                this.getCampaignHourlyReportByPage(accessToken,advertiserId,map.get("startDate"),map.get("endDate"),null,null);
                this.getGroupHourlyReportByPage(accessToken,advertiserId,map.get("startDate"),map.get("endDate"),null,null);
                this.getCreativeHourlyReportByPage(accessToken,advertiserId,map.get("startDate"),map.get("endDate"),null,null);
            }
        }
    }

    @Override
    public void getMaterial(String accessToken, Long advertiserId) {
        getCampaignList(accessToken,advertiserId);
        getGroupList(accessToken,advertiserId);
        getCreativeList(accessToken,advertiserId);
    }

    private void getCampaignList(String accessToken, Long advertiserId){
        KuaishouResult<KuaishouCampaign> campaignResult = kuaishouInterfaceService.getCampaignList(accessToken,advertiserId);
        List<KuaishouCampaign> list = campaignResult.getData().getDetails();
        for(KuaishouCampaign campaign : list){
            campaign.setAccountId(advertiserId);
            kuaishouCampaignService.saveOrUpdate(campaign);
        }
    }

    private void getGroupList(String accessToken, Long advertiserId){
        KuaishouResult<KuaishouGroup> groupResult = kuaishouInterfaceService.getGroupList(accessToken,advertiserId);
        List<KuaishouGroup> list = groupResult.getData().getDetails();
        for(KuaishouGroup group : list){
            group.setAccountId(advertiserId);
            KuaishouAppInfo appInfo = group.getDiverseData();
            KuaishouSchedule schedule = group.getSchedule();
            if(appInfo != null){
                kuaishouAppInfoService.saveOrUpdate(appInfo);

            }
            if(schedule != null){
                schedule.setGroupId(group.getGroupId());
                kuaishouScheduleService.saveOrUpdate(schedule);

            }
            kuaishouGroupService.saveOrUpdate(group);
        }
    }

    private void getCreativeList(String accessToken, Long advertiserId){
        KuaishouResult<KuaishouCreative> creativeResult = kuaishouInterfaceService.getCreativeList(accessToken,advertiserId);
        List<KuaishouCreative> list = creativeResult.getData().getDetails();
        for(KuaishouCreative creative : list){
            creative.setAccountId(advertiserId);
            kuaishouCreativeService.saveOrUpdate(creative);
        }
    }

    private void getAccountDailyReportByPage(String accessToken, Long advertiserId, String startDate, String endDate,Integer pageSize,Integer pageNum){
        if(pageSize == null){
            pageSize = 100;
        }
        if(pageNum == null){
            pageNum = 1;
        }
        KuaishouResult<KuaishouReportDailyAccount> result = null;
        result = kuaishouInterfaceService.getAccountDailyReport(accessToken,advertiserId,startDate,endDate,pageSize,pageNum);
        List<KuaishouReportDailyAccount> list = result.getData().getDetails();
        for(KuaishouReportDailyAccount account : list){
            account.setAccountId(advertiserId);
            kuaishouReportDailyAccountService.remove(
                    new QueryWrapper<KuaishouReportDailyAccount>().lambda()
                            .eq(KuaishouReportDailyAccount::getAccountId,account.getAccountId())
                            .eq(KuaishouReportDailyAccount::getStatDate,account.getStatDate()));
            kuaishouReportDailyAccountService.save(account);
        }
        int totalCount = result.getData().getTotalCount();
        if(pageNum*pageSize < totalCount){
            pageNum++;
            getAccountDailyReportByPage(accessToken,advertiserId,startDate,endDate,pageSize,pageNum);
        }
    }

    private void getAccountHourlyReportByPage(String accessToken, Long advertiserId, String startDate, String endDate, Integer pageSize,Integer pageNum){
        if(pageSize == null){
            pageSize = 100;
        }
        if(pageNum == null){
            pageNum = 1;
        }
        KuaishouResult<KuaishouReportHourlyAccount> result = null;
        result = kuaishouInterfaceService.getAccountHourlyReport(accessToken,advertiserId,startDate,endDate,pageSize,pageNum);
        List<KuaishouReportHourlyAccount> list = result.getData().getDetails();
        for(KuaishouReportHourlyAccount account : list){
            account.setAccountId(advertiserId);
            kuaishouReportHourlyAccountService.remove(
                    new QueryWrapper<KuaishouReportHourlyAccount>().lambda()
                            .eq(KuaishouReportHourlyAccount::getAccountId,account.getAccountId())
                            .eq(KuaishouReportHourlyAccount::getStatHour,account.getStatHour())
                            .eq(KuaishouReportHourlyAccount::getStatDate,account.getStatDate()));
            kuaishouReportHourlyAccountService.save(account);
        }
        int totalCount = result.getData().getTotalCount();
        if(pageNum*pageSize < totalCount){
            pageNum++;
            getAccountHourlyReportByPage(accessToken,advertiserId,startDate,endDate,pageSize,pageNum);
        }
    }

    private void getCampaignDailyReportByPage(String accessToken, Long advertiserId, String startDate, String endDate,Integer pageSize,Integer pageNum){
        if(pageSize == null){
            pageSize = 100;
        }
        if(pageNum == null){
            pageNum = 1;
        }
        KuaishouResult<KuaishouReportDailyCampaign> result = kuaishouInterfaceService.getCampaignDailyReport(accessToken,advertiserId,startDate,endDate,pageSize,pageNum);
        List<KuaishouReportDailyCampaign> list = result.getData().getDetails();
        for(KuaishouReportDailyCampaign campaign : list){
            campaign.setAccountId(advertiserId);
            kuaishouReportDailyCampaignService.remove(
                    new QueryWrapper<KuaishouReportDailyCampaign>().lambda()
                            .eq(KuaishouReportDailyCampaign::getAccountId,campaign.getAccountId())
                            .eq(KuaishouReportDailyCampaign::getCampaignId,campaign.getCampaignId())
                            .eq(KuaishouReportDailyCampaign::getStatDate,campaign.getStatDate()));
            kuaishouReportDailyCampaignService.save(campaign);
        }
        int totalCount = result.getData().getTotalCount();
        if(pageNum*pageSize < totalCount){
            pageNum++;
            getCampaignDailyReportByPage(accessToken,advertiserId,startDate,endDate,pageSize,pageNum);
        }
    }

    private void getCampaignHourlyReportByPage(String accessToken, Long advertiserId, String startDate, String endDate,Integer pageSize,Integer pageNum){
        if(pageSize == null){
            pageSize = 100;
        }
        if(pageNum == null){
            pageNum = 1;
        }
        KuaishouResult<KuaishouReportHourlyCampaign> result = kuaishouInterfaceService.getCampaignHourlyReport(accessToken,advertiserId,startDate,endDate,pageSize,pageNum);
        List<KuaishouReportHourlyCampaign> list = result.getData().getDetails();
        for(KuaishouReportHourlyCampaign campaign : list){
            campaign.setAccountId(advertiserId);
            kuaishouReportHourlyCampaignService.remove(
                    new QueryWrapper<KuaishouReportHourlyCampaign>().lambda()
                            .eq(KuaishouReportHourlyCampaign::getAccountId,campaign.getAccountId())
                            .eq(KuaishouReportHourlyCampaign::getCampaignId,campaign.getCampaignId())
                            .eq(KuaishouReportHourlyCampaign::getStatHour,campaign.getStatHour())
                            .eq(KuaishouReportHourlyCampaign::getStatDate,campaign.getStatDate()));
            kuaishouReportHourlyCampaignService.save(campaign);
        }
        int totalCount = result.getData().getTotalCount();
        if(pageNum*pageSize < totalCount){
            pageNum++;
            getCampaignHourlyReportByPage(accessToken,advertiserId,startDate,endDate,pageSize,pageNum);
        }
    }

    private void getGroupDailyReportByPage(String accessToken, Long advertiserId, String startDate, String endDate,Integer pageSize,Integer pageNum){
        if(pageSize == null){
            pageSize = 100;
        }
        if(pageNum == null){
            pageNum = 1;
        }
        KuaishouResult<KuaishouReportDailyGroup> result = kuaishouInterfaceService.getGroupDailyReport(accessToken,advertiserId,startDate,endDate,pageSize,pageNum);
        List<KuaishouReportDailyGroup> list = result.getData().getDetails();
        for(KuaishouReportDailyGroup group : list){
            group.setAccountId(advertiserId);
            kuaishouReportDailyGroupService.remove(
                    new QueryWrapper<KuaishouReportDailyGroup>().lambda()
                            .eq(KuaishouReportDailyGroup::getAccountId,group.getAccountId())
                            .eq(KuaishouReportDailyGroup::getGroupId,group.getGroupId())
                            .eq(KuaishouReportDailyGroup::getStatDate,group.getStatDate()));
            kuaishouReportDailyGroupService.save(group);
        }
        int totalCount = result.getData().getTotalCount();
        if(pageNum*pageSize < totalCount){
            pageNum++;
            getGroupDailyReportByPage(accessToken,advertiserId,startDate,endDate,pageSize,pageNum);
        }
    }

    private void getGroupHourlyReportByPage(String accessToken, Long advertiserId, String startDate, String endDate,Integer pageSize,Integer pageNum){
        if(pageSize == null){
            pageSize = 100;
        }
        if(pageNum == null){
            pageNum = 1;
        }
        KuaishouResult<KuaishouReportHourlyGroup> result = kuaishouInterfaceService.getGroupHourlyReport(accessToken,advertiserId,startDate,endDate,pageSize,pageNum);
        List<KuaishouReportHourlyGroup> list = result.getData().getDetails();
        for(KuaishouReportHourlyGroup group : list){
            group.setAccountId(advertiserId);
            kuaishouReportHourlyGroupService.remove(
                    new QueryWrapper<KuaishouReportHourlyGroup>().lambda()
                            .eq(KuaishouReportHourlyGroup::getAccountId,group.getAccountId())
                            .eq(KuaishouReportHourlyGroup::getGroupId,group.getGroupId())
                            .eq(KuaishouReportHourlyGroup::getStatHour,group.getStatHour())
                            .eq(KuaishouReportHourlyGroup::getStatDate,group.getStatDate()));
            kuaishouReportHourlyGroupService.save(group);
        }
        int totalCount = result.getData().getTotalCount();
        if(pageNum*pageSize < totalCount){
            pageNum++;
            getGroupHourlyReportByPage(accessToken,advertiserId,startDate,endDate,pageSize,pageNum);
        }
    }

    private void getCreativeDailyReportByPage(String accessToken, Long advertiserId, String startDate, String endDate,Integer pageSize,Integer pageNum){
        if(pageSize == null){
            pageSize = 100;
        }
        if(pageNum == null){
            pageNum = 1;
        }
        KuaishouResult<KuaishouReportDailyCreative> result = kuaishouInterfaceService.getCreativeDailyReport(accessToken,advertiserId,startDate,endDate,pageSize,pageNum);
        List<KuaishouReportDailyCreative> list = result.getData().getDetails();
        for(KuaishouReportDailyCreative creative : list){
            creative.setAccountId(advertiserId);
            kuaishouReportDailyCreativeService.remove(
                    new QueryWrapper<KuaishouReportDailyCreative>().lambda()
                            .eq(KuaishouReportDailyCreative::getAccountId,creative.getAccountId())
                            .eq(KuaishouReportDailyCreative::getCreativeId,creative.getCreativeId())
                            .eq(KuaishouReportDailyCreative::getStatDate,creative.getStatDate()));
            kuaishouReportDailyCreativeService.save(creative);
        }
        int totalCount = result.getData().getTotalCount();
        if(pageNum*pageSize < totalCount){
            pageNum++;
            getCreativeDailyReportByPage(accessToken,advertiserId,startDate,endDate,pageSize,pageNum);
        }
    }

    private void getCreativeHourlyReportByPage(String accessToken, Long advertiserId, String startDate, String endDate,Integer pageSize,Integer pageNum){
        if(pageSize == null){
            pageSize = 100;
        }
        if(pageNum == null){
            pageNum = 1;
        }
        KuaishouResult<KuaishouReportHourlyCreative> result = kuaishouInterfaceService.getCreativeHourlyReport(accessToken,advertiserId,startDate,endDate,pageSize,pageNum);
        List<KuaishouReportHourlyCreative> list = result.getData().getDetails();
        for(KuaishouReportHourlyCreative creative : list){
            creative.setAccountId(advertiserId);
            kuaishouReportHourlyCreativeService.remove(
                    new QueryWrapper<KuaishouReportHourlyCreative>().lambda()
                            .eq(KuaishouReportHourlyCreative::getAccountId,creative.getAccountId())
                            .eq(KuaishouReportHourlyCreative::getCreativeId,creative.getCreativeId())
                            .eq(KuaishouReportHourlyCreative::getStatHour,creative.getStatHour())
                            .eq(KuaishouReportHourlyCreative::getStatDate,creative.getStatDate()));
            kuaishouReportHourlyCreativeService.save(creative);
        }
        int totalCount = result.getData().getTotalCount();
        if(pageNum*pageSize < totalCount){
            pageNum++;
            getCreativeHourlyReportByPage(accessToken,advertiserId,startDate,endDate,pageSize,pageNum);
        }
    }
}
